import geopy
from geopy.distance import geodesic
import numpy as np

bearings = [
    0,
    90
]


def __get_lat_lon_deltas(lat, lon, accuracy):
    origin = geopy.Point(lat, lon)
    dlat, dlon = [], []
    for b in bearings:
        dest = geodesic(meters=accuracy).destination(origin, b)
        dlat.append(abs(lat - dest.latitude))
        dlon.append(abs(lon - dest.longitude))

    dlat.sort(reverse=True)
    dlon.sort(reverse=True)
    return dlat[0], dlon[0]


def __sorted_gauss_samples(l, d, count):
    res = np.random.normal(l, d, count)
    res.sort()
    return res


def append_geo(vector: np.ndarray, lat, lon, accuracy) -> np.ndarray:
    dlat, dlon = __get_lat_lon_deltas(lat, lon, accuracy)
    return np.concatenate((
        vector.reshape(512),
        __sorted_gauss_samples(lat, dlat, 256),
        __sorted_gauss_samples(lon, dlon, 256)
    ))
